#include "lip.h"
#include "mper.h"
#include "upr.h"
static  char *idv= "2007-12-19  V 4.1d";   /* must start always as YYYY-MM-DD */
#define  zfwrite  zfwrite_c   /*  older parameter version of zfwrite used */
#ifndef  DEFAULT_LINE_LEN
#define  DEFAULT_LINE_LEN  255
#endif
#define  ENTRY   1
#define  COMPACT   0
#undef   CHAIN_INFO

static database  *db = 0;
static unsigned  table_size= TABSIZE, prime_heapsize=PRIMEHEAP, 
                 factorisations= FACTSIZE, power_heapsize=POWERHEAP;
static unsigned  entry = ENTRY, compact = COMPACT, flags = 0;
/***   used bits of flags:  0,5,6  **/
static void do_update_indices(int);
static int insert_prime_at(unsigned, long *);

 
#define  TOP   "^"
#define  SPACE " "
#define  SET  " = "


static unsigned round_up_2power(unsigned t)
{  if (!(t&t-1))
      return  t;
   else if (t > ~((~0U)>>1))
      return 0;
   else
   {  unsigned  i;
      for (i=1;i<t;i+=i)
         if (!i)  return 0;
      return i;
   }
   return t;
}


int create_heap(unsigned max_two_expo, unsigned sievesize)
{
unsigned  h, i, j, k;
static long  *one=0, *d=0, *base=0, *pri[MAXFACTORS];
unsigned  me, exp[MAXFACTORS];
int  len;
char  *sieve;

   if (!db)
      db= create_db(table_size,prime_heapsize,factorisations,power_heapsize);
   sieve= (char *) calloc(sievesize, sizeof(char));
   if (!sieve)
      error_stop(8,"in create_heap: ");
   for (i=1;i<sievesize;i++)
      sieve[i]='\n';
   for (i=2;i<sievesize;i++)
      if (sieve[i])
         for (j=i*i;j<sievesize;j+=i)
            sieve[j]='\0';
   flags |= 1;
   db->nopri=1;  /* first table-entry unused */
   db->next_prime = db->longprime;
   db->next_sigma = db->list;
   for (i=2;i<sievesize;i++)
      if (sieve[i])
      {  if (db->nopri > table_size)
            error_stop(2,"in create_heap: ");
         db->table[db->nopri].pri_addr = db->next_prime;
         if (db->next_prime+2 > db->longprime+prime_heapsize)
            error_stop(3,"in create_heap: ");
         *db->next_prime++ = 1;
         *db->next_prime++ = (longint) i;
         me= (max_two_expo-2)/(2*i-3) + 2;  /* must be positive */
         db->table[db->nopri].maxexpo = me;
         db->table[db->nopri].sigma = db->next_sigma;
         for (h=0;h<me;h++)
         {  db->next_sigma->fact_addr = (pri_power *) 0;
            db->next_sigma++;
         }
         if (db->next_sigma > db->list+factorisations)
            error_stop(4,"in create_heap: ");
         db->table[db->nopri].links = 0;
         db->nopri++;
      }
   free(sieve);
   zintoz(1,&one);
   db->next_power= db->powerheap;
   do {
      h=0;
      for (k=1;k<db->nopri;k++)
      {  vect  *list_ptr;
         base= (long *) db->table[k].pri_addr;
         me = db->table[k].maxexpo;
         list_ptr = db->table[k].sigma;
#ifndef  ONE_UP
         zcopy(one,&d);
#else
         zzero(&d);
#endif
         for (i=1;i<=me;i++,list_ptr++)
         {
#ifndef  ONE_UP
            zmulin(base,&d);
            zadd(d,one,&d);
#else
            zadd(d,one,&d);
            zmulin(base,&d);
            zsub(d,one,&d);
#endif
            if (list_ptr->fact_addr)
               continue; 
            len= factor(d,pri,exp);
            if (len <= 0)
               error_stop(13,"in create_heap: ");
            if (len > MAXFACTORS)
               error_stop(6,"in create_heap: ");
            if (db->next_power+len >= db->powerheap+power_heapsize)
               error_stop(5,"in create_heap: ");
            list_ptr->fact_addr = db->next_power;
            list_ptr->no_factors = len;
            for (j=0;j<len;j++)
            {  info  *taddr;
               unsigned  index;
               if (!(index = lookup_primeaddr(pri[j])) )
               {  index= get_primeaddr(pri[j]);
                  if (index <= k)
                     k++, h++;
               }
               taddr= db->table+index;
               db->next_power->base = taddr;
               taddr->links += 1;
               db->next_power->expo = exp[j];
               db->next_power++;
               if (exp[j] > taddr->maxexpo)
               {  alloc_factoring(index,exp[j]-taddr->maxexpo);
                  list_ptr = db->table[k].sigma+i-1;
                  me = db->table[k].maxexpo;
               }
            }
         } 
      }
   } while(h);
   for (i=0;i<MAXFACTORS;i++)
      zfree(&pri[i]);
   return 0;
}


unsigned  get_maxindex(void)
{
   if (!db)  error_stop(7,"in get_maxindex: ");
   return  db->nopri-1;
}


static int insert_prime_at(unsigned i, long * number)
{
   unsigned  k;
   long  prilen;
   if (!db)  error_stop(7,"in insert_prime_at: ");
   pri_power *heap_ptr;
   prilen = *number;
   if (db->next_prime+1+prilen > db->longprime+prime_heapsize)
      error_stop(3,"in insert_prime_at: ");
   if (db->nopri == table_size)
      error_stop(2,"in insert_prime_at: ");
   flags |= 32;  /*** begin of critical part ***/
   for (k=db->nopri;k>i;k--)
      db->table[k] = db->table[k-1];
   for (heap_ptr=db->powerheap;heap_ptr < db->next_power;heap_ptr++)
      if (heap_ptr->base >= db->table+i)
         heap_ptr->base += 1;
   db->table[i].maxexpo = 0;
   flags &= ~32;  /*** end of critical part ***/
   *db->next_prime = prilen;
   for (k=1;k<= prilen;k++)
      db->next_prime[k] = *(number+k);
   db->table[i].pri_addr = db->next_prime;
   db->next_prime += prilen+1;
   db->table[i].sigma = (vect *) 0;
   db->table[i].links = 0;
   db->nopri++;
   do_update_indices(i);
   flags |= 1;
   return  0;
}


unsigned  lookup_primeaddr(long * number)
{
   unsigned  i, j, k;
   int  h;
   if (!db)  error_stop(7,"in lookup_primeaddr: ");
   if (!is_valid(number) || !db->nopri)
      return  0;
   i= 1;
   j= db->nopri-1;
   while (i <= j)
   {
      k= (i+j)/2;
      if ((h=zcompare(db->table[k].pri_addr, number)) > 0)
         j= k-1;
      else if (h < 0)
         i= k+1;
      else
         return  k;
   }
   return  0;
}


int  get_primeaddr(long * number)
{
   unsigned  i, j, k;
   int  h;
   if (!db)  error_stop(7,"in get_primeaddr: ");
   if (!is_valid(number))
      return  0;
   i= 1;
   j= db->nopri-1;
   while (i <= j)
   {
      k= (i+j)/2;
      if ((h=zcompare(db->table[k].pri_addr, number)) > 0)
         j= k-1;
      else if (h < 0)
         i= k+1;
      else
         return  k;
   }
   if (h = insert_prime_at(i,number))
      return  -h;
   return  i;
}


long * get_prime(unsigned index)
{
   if (!db)  error_stop(7,"in get_prime: ");
   if (index <= 0 || index >= db->nopri)
      error_stop(1,"in get_prime: ");
   return  (long*) db->table[index].pri_addr;
}


int valid_table_addr(unsigned index)
{
   static long *base;
   if (!db)  error_stop(7,"in valid_table_addr: ");
   if (index <= 0 || index >= db->nopri)
      return 1;
   else
   {  base = (long *) db->table[index].pri_addr;
      if (base < (long *) db->longprime || base >= (long *) db->next_prime)
         return 2;
      else if (*base <= 0  ||  base + *base >= (long *) db->next_prime)
         return 3;
   }
   return  0;
}


unsigned  get_maxexpo(unsigned index)
{
   if (!db)  error_stop(7,"in get_maxexpo: ");
   if (index <= 0 || index >= db->nopri)
      error_stop(1,"in get_max_expo: ");
   return  db->table[index].maxexpo;
}


int alloc_factoring(unsigned index, int anz)
{
   int  h, i;
   unsigned  me;
   info  *taddr;
   vect   *list_ptr;

   if (!db)  error_stop(7,"in alloc_factoring: ");
   taddr = db->table+index;
   if (index <= 0 || index >= db->nopri)
      error_stop(1,"in alloc_factoring: ");
   me = taddr->maxexpo;
   if (!anz || -anz > (int) me)
      return  0;
   if (anz > 0)
   {  if (db->next_sigma+anz > db->list+factorisations)
         error_stop(4,"in alloc_factoring: ");
      flags |= 32;  /*** begin of critical part ***/
      if (me)
      {  list_ptr= db->next_sigma - 1;
         for (i= db->next_sigma-taddr->sigma-me;i--;list_ptr--)
            *(list_ptr+anz) = *list_ptr;
      }
      else
         taddr->sigma= db->next_sigma;
      list_ptr = taddr->sigma+me-1;
      for (i=anz;i;i--)
         list_ptr[i].fact_addr = (pri_power *) 0;
   }
   else /* anz < 0 */
   {  for (i=me;i>me+anz;i--)
         if (taddr->sigma[i-1].fact_addr)
            return  0;
      flags |= 32;  /*** begin of critical part ***/
      for (list_ptr= taddr->sigma+me;list_ptr != db->next_sigma;list_ptr++)
         *(list_ptr+anz) = *list_ptr;
   }
   if (taddr->sigma+me != db->next_sigma)
      for (h=1;h<db->nopri;h++)
         if (db->table[h].sigma >= taddr->sigma && h != index) /* caution! */
            db->table[h].sigma += anz;
   db->next_sigma += anz;
   me += anz;
   if (!(taddr->maxexpo = me))
      taddr->sigma = (vect *) 0;
   flags &= ~32;  /*** end of critical part ***/
   flags |= 1;
   return  anz;
}


int valid_factoring(unsigned index, unsigned me)
{
   pri_power *heap_ptr;
   if (!db)  error_stop(7,"in valid_factoring: ");
   if (index <= 0 || index >= db->nopri)
      error_stop(1,"in valid_factoring: ");
   if (me <= 0 || me > db->table[index].maxexpo)
      return  1;
   if (!(heap_ptr=db->table[index].sigma[me-1].fact_addr))
      return  2;
   if (heap_ptr < db->powerheap || heap_ptr >= db->next_power)
      return  3;
   return  0;
}


unsigned size_of_factoring(unsigned index, unsigned me)
{
   vect  *list_ptr;
   if (!db)  error_stop(7,"in size_of_factoring: ");
   if (index <= 0 || index >= db->nopri)
      error_stop(1,"in size_of_factoring: ");
   if (me <= 0 || me > db->table[index].maxexpo)
      return  0;
   list_ptr=db->table[index].sigma+me-1;
   if (!list_ptr->fact_addr)
      return  0;
   return  list_ptr->no_factors;
}


int write_sigma_chain(unsigned index, unsigned me, unsigned bits)
{
   int  h, i=0, j;
   pri_power  *heap_ptr;
   vect  *list_ptr;
   info  *taddr;
   FILE  *fp = stdout;
   if (!db)  error_stop(7,"in write_sigma_chain: ");
   taddr = db->table+index;
   if (index <= 0 || index >= db->nopri)
      error_stop(1,"in write_sigma_chain: ");
   if (!me || me > taddr->maxexpo)
      return  0;
   list_ptr = taddr->sigma+me-1;
   if (! (heap_ptr = list_ptr->fact_addr) )
      return  0;
   if (bits < 2)  bits=2;
   if (z2log(taddr->pri_addr) * me <= bits)
      return  0;
   zfwrite(fp,taddr->pri_addr,2048,"","");
   fprintf(fp,"%s%u%s",TOP,me,SET);
   for (j=list_ptr->no_factors;j;j--,heap_ptr++)
   {  zfwrite(fp,heap_ptr->base->pri_addr,2048,"","");
      if ((h = heap_ptr->expo) != 1)
         fprintf(fp,"%s%d",TOP,h);
      fprintf(fp,"%s",(j==1?"\n":SPACE)); 
   }
   fflush(fp);
   i++;
   heap_ptr = list_ptr->fact_addr;
   for (j=list_ptr->no_factors;j;j--,heap_ptr++)
      i += write_sigma_chain(heap_ptr->base-db->table,heap_ptr->expo,bits);
   return  i;
}


int write_factoring(unsigned index, unsigned me, char * buffer)
{
   int  h, i, j;
   pri_power  *heap_ptr;
   vect    *list_ptr;
   if (!db)  error_stop(7,"in write_factoring: ");
   if (index <= 0 || index >= db->nopri)
      error_stop(1,"in write_factoring: ");
   if (!me || me > db->table[index].maxexpo)
      return  (int) (buffer[0]='\0');
   i=0;
   list_ptr = db->table[index].sigma+me-1;
   if (heap_ptr = list_ptr->fact_addr)
      for (j=list_ptr->no_factors;j;j--,heap_ptr++)
      {  i+= zswrite(buffer+i,heap_ptr->base->pri_addr);
         if ((h = heap_ptr->expo) != 1)
            sprintf(buffer+i,"%s%d%s",TOP,h,SPACE);
         else
            sprintf(buffer+i,"%s",SPACE);
         for (i++;buffer[i];i++);
      }
   buffer[i]='\0';
   return  i;
}


int read_factoring(unsigned index, unsigned me, char * buffer)
{
   int  h, i, j;
   static long  *pri[MAXFACTORS];
   unsigned  len, exp[MAXFACTORS];
   char  delim;
   if (!db)  error_stop(7,"in read_factoring: ");
   if (index <= 0 || index >= db->nopri)
      error_stop(1,"in read_factoring: ");
   if (!me || me > db->table[index].maxexpo)
      return -1;
   for (i=0;i<MAXFACTORS;i++)
      pri[i] = (long *) 0;
   j=0;
   for (len=0;;len++)
   {  for (;buffer[j]<'0' || buffer[j]>'9';j++)
         if (buffer[j]<' ')  break;
      if (buffer[j]<' ')  break;
      for (i=j;buffer[i]>='0' && buffer[i]<='9';i++);
      if (i==j)  break;
      if (len > MAXFACTORS)
         error_stop(6,"in read_factoring: ");
      delim= buffer[i];
      buffer[i]='\0';
      zsread(buffer+j,&pri[len]);
      buffer[i]=delim;
      j=i;
      while(buffer[i]&&TOP[j-i]&&buffer[i]==TOP[j-i])
         i++;
      if (!TOP[j-i])
      {  for (j=i;buffer[j]<'0' || buffer[j]>'9';j++)
            if (buffer[j]<' ')  break;
         if (buffer[j]<' ')  break;
         for (i=j;buffer[i]>='0' && buffer[i]<='9';i++);
         if (i==j)  break;
         delim= buffer[i];
         buffer[i]='\0';
         sscanf(buffer+j,"%u",&exp[len]);
         buffer[i]=delim;
         j=i;
      }
      else
         exp[len]=1;
      j++;
   }
   h= update_factoring (index,me,len,pri,exp);
   for (i=0;i<MAXFACTORS;i++)
      zfree(&pri[i]);
   return h;
}


int compute_factoring(unsigned index, unsigned me)
{
   int  h, i, len;
   static long  *one=0, *d=0, *base, *pri[MAXFACTORS];
   unsigned  exp[MAXFACTORS];
   if (!db)  error_stop(7,"in compute_factoring: ");
   if (index <= 0 || index >= db->nopri)
      error_stop(1,"in compute_factoring: ");
   if (!me || me > db->table[index].maxexpo)
      return -1;
   for (i=0;i<MAXFACTORS;i++)
      pri[i] = (long *) 0;
   base = (long *) db->table[index].pri_addr;
   zintoz(1,&one);
   zintoz(1,&d);
   for (i=0;i<me;i++)
   {  zmulin(base,&d);
#ifndef  ONE_UP
      zadd(d,one,&d);
#endif
   }
#ifdef  ONE_UP
   zsub(d,one,&d);
#endif
   len= factor(d,pri,exp);
   if (len <= 0)
      error_stop(13,"in compute_factoring: ");
   if (len > MAXFACTORS)
      error_stop(6,"in compute_factoring: ");
   h= update_factoring (index,me,len,pri,exp);
   for (i=0;i<MAXFACTORS;i++)
      zfree(&pri[i]);
   return  h;
}


int chain_factoring(long * number, unsigned me)
{
   int  h, i, k, len;
   static long  *one=0, *d=0, *pri[MAXFACTORS+1];
   unsigned  exp[MAXFACTORS], index;
   info  *taddr;
   pri_power  *heap_ptr;
   if (!db)  error_stop(7,"in chain_factoring: ");
#ifdef  ONE_UP
   error_stop(9,"in chain_factoring: ");
#endif
   if (!me)
      return  0;
   for (i=0;i<MAXFACTORS;i++)
      pri[i] = (long *) 0;
   zcopy(number,&pri[0]);
   exp[0] = me;
   k=1;  /* chain_counter */
   for (h=0;h<k;h++)
   {  number= pri[h];
      me = exp[h];
      index=get_primeaddr(number);
      taddr = db->table+index;
      if (me > taddr->maxexpo)
         alloc_factoring(index,me-taddr->maxexpo);
      if (heap_ptr = taddr->sigma[me-1].fact_addr)
      {  len = taddr->sigma[me-1].no_factors;
         if (len+k > MAXFACTORS)
            error_stop(6,"in chain_factoring: sigma chain too complex. ");
         for (i=0;i<len;i++,heap_ptr++)
         {  zcopy( (long*) heap_ptr->base->pri_addr, &pri[k+i]);
            exp[k+i]=heap_ptr->expo;
         }
      }
      else
      {  zintoz(1,&one);
         zintoz(1,&d);
#ifdef  CHAIN_INFO
         fprintf(stderr,"try with expo %d: ",me); zfwriteln(stderr,number);
#endif
         for (i=0;i<me;i++)
         {  zmulin(number,&d);
            zadd(d,one,&d);
         }
         len= factor(d,pri+k,exp+k);
         if (len <= 0)
            error_stop(13,"in chain_factoring: ");
         if (len+k > MAXFACTORS)
            error_stop(6,"in chain_factoring: sigma chain too complex. ");
      }
      len += k;
      if (!taddr->sigma[me-1].fact_addr)
      {  for (i=k;i<len;i++)
         {  index=get_primeaddr(pri[i]);
            if (exp[i] > db->table[index].maxexpo )
               alloc_factoring(index,exp[i]-db->table[index].maxexpo);
         }
         index= lookup_primeaddr(number);
         update_factoring (index,me,len-k,pri+k,exp+k);
#ifdef  CHAIN_INFO
         zfwrite(stderr,number,DEFAULT_LINE_LEN,"","");
         fprintf(stderr,"%s%u sigma-factorization stored\n",TOP,me);
#endif
      }
      for (i=k;i<len;i++)
      {  index=lookup_primeaddr(pri[i]);
         taddr= db->table+index;
         if (exp[i] > taddr->maxexpo )
            alloc_factoring(index,exp[i]-taddr->maxexpo);
         if (!taddr->sigma[exp[i]-1].fact_addr)   /* further chain to check */
         {  if (i != k)
            {  zswap(&pri[k],&pri[i]);
               exp[k]^=exp[i]; exp[i]^=exp[k]; exp[k]^=exp[i];
            }
            k++;
         }
      }
   }
   for (i=0;i<MAXFACTORS;i++)
      zfree(&pri[i]);
   return  k;
}


int update_factoring(unsigned index, unsigned me, unsigned len,
                 long * pri[MAXFACTORS], unsigned exp[MAXFACTORS])
{
   int  h, j;
   vect  *list_ptr;
   if (!db)  error_stop(7,"in update_factoring: ");
   if (!me || me > db->table[index].maxexpo)
      return -1;
   list_ptr = db->table[index].sigma+me-1;
   if (list_ptr->fact_addr)
      return -2;
   if (db->next_power+len > db->powerheap+power_heapsize)
      error_stop(5,"in update_factoring: ");
   list_ptr->fact_addr = db->next_power;
   h= list_ptr->no_factors = 0;
   for (j=0;j<len;list_ptr->no_factors = ++j)
   {  if (!( db->next_power->base = db->table + 
             (entry ? get_primeaddr(pri[j]) : lookup_primeaddr(pri[j])) ))
      {  h=j+1;
         if (!entry)
         {  fprintf(stderr,"prime not in heap: ");
            zfwrite(stderr, pri[j],DEFAULT_LINE_LEN,"","");
            fprintf(stderr,"\n");
         }
         else
         {  fprintf(stderr,"not a prime: ");
            zfwrite(stderr, pri[j],DEFAULT_LINE_LEN,"","");
            fprintf(stderr,"\n");
         }
      }
      db->next_power->expo= exp[j];
      db->next_power->base->links += 1;
      db->next_power++;
   }
   flags |= 1;
   return  h; 
}


int add_factoring(unsigned index)
{
   if (!db)  error_stop(7,"in add_factoring: ");
   alloc_factoring(index,1);
   return  compute_factoring(index,db->table[index].maxexpo);
}


int get_factoring(unsigned index, unsigned me, unsigned * len,
                  long * pri[MAXFACTORS], unsigned exp[MAXFACTORS])
{
   unsigned  j;
   pri_power  *heap_ptr;
   info  *taddr;

   if (!db)  error_stop(7,"in get_factoring: ");
   if (index <= 0 || index >= db->nopri)
      error_stop(1,"in get_factoring: ");
   taddr = db->table+index;
   if (!me || me > taddr->maxexpo)
      return -1;
   if(heap_ptr = taddr->sigma[me-1].fact_addr)
   {
      *len= taddr->sigma[me-1].no_factors;
      for (j=0;j< *len;j++,heap_ptr++)
      {  zcopy(heap_ptr->base->pri_addr, &pri[j]);
         exp[j] = heap_ptr->expo;
      }
      return 0;
   }
   else
      return -2;
}


int size_info(void * db_info[16])
{
   unsigned  h, i, j, k;
   vect  *list_ptr;
   if (!db)  error_stop(7,"in size_info: ");
   if (3!=sscanf(idv,"%4u-%2u-%2u",&h,&i,&j))
      return  -1;
   if (j > 31 || i > 12 || h < 1970)  return  -2;
   k= (32*(h*13+(i-1))+j);
   for (j=0, i= (unsigned) ~0U ; i ; i>>=1, j++);
   if (j%8)
      return -3;
   j /= 8*sizeof(unsigned);
   for (h= -3, i= j* sizeof(void*) ; i ; i>>=1, h++);
   k |= (h&3)<<20;
   for (h= -3, i= j* sizeof(longint) ; i ; i>>=1, h++);
   k |= (h&3)<<22;
   for (h= -3, i= j* sizeof(unsigned) ; i ; i>>=1, h++);
   k |= (h&3)<<24;
   db_info[0] = (void *) k;
   db_info[1] = (void *) db->table;
   db_info[2] = (void *) db->nopri;
   db_info[3] = (void *) db->longprime;
   db_info[4] = (void *) (db->next_prime - db->longprime);
   db_info[5] = (void *) db->list;
   db_info[6] = (void *) (db->next_sigma - db->list);
   db_info[7] = (void *) db->powerheap;
   db_info[8] = (void *) (db->next_power - db->powerheap);
   db_info[10]= (void *) MAXFACTORS;
   db_info[11]= (void *) table_size;
   db_info[12]= (void *) prime_heapsize;
   db_info[13]= (void *) factorisations;
   db_info[14]= (void *) power_heapsize;
   db_info[15]= (void *) 0;
#ifdef  ONE_UP
   db_info[15] |= 1;
#endif
   h=0;
   for (list_ptr= db->list;list_ptr<db->next_sigma;list_ptr++)
      if (list_ptr->fact_addr  &&  list_ptr->no_factors > h)
         h=list_ptr->no_factors;
   db_info[9] = (void *) h;
   return  16;
}


void heap_info()
{
   FILE  *fp = stdout;
   int  h, i, k;
   unsigned  count[18];
   vect  *list_ptr;
   if (!db)  error_stop(7,"in heap_info: ");
   h=0;
   for (list_ptr= db->list;list_ptr!=db->next_sigma;list_ptr++)
      if (list_ptr->fact_addr  &&  list_ptr->no_factors > h)
         h=list_ptr->no_factors;
   fprintf(fp,"primes=%u(%u)  factorisations=%lu(%u)  mper %s\n"
              "powerheap=%lu(%u)  primeheap=%lu(%u)  max factors=(%u)%u\n",
              db->nopri-1,table_size,
              db->next_sigma-db->list,factorisations, idv,
              db->next_power-db->powerheap,power_heapsize,
              db->next_prime-db->longprime,prime_heapsize, h,MAXFACTORS);
   for (h=1;h<=25;h++)
      fprintf(fp,"%3lu",db->table[h].pri_addr[1]);
   fprintf(fp,"\n");
   for (h=1;h<=25;h++)
      fprintf(fp,"%3u",db->table[h].maxexpo);
   fprintf(fp,"\n");
   fflush(fp);
   k=1;
   i=0;
   fprintf(fp,"#primes(#longints):");
   for (h=1;h<db->nopri;h++,i++)
      while (db->table[h].pri_addr[0] > k)
      {   if (k<=2)
             fprintf(fp," %u(%u)",i,k);
          else
             fprintf(fp," %u(%u-%u)",i,k/2+1,k);
          k += k;
          i=0;
      }
   if (i)
      fprintf(fp," %u(%u-%lu)",i,k/2+1,db->table[h-1].pri_addr[0]);
   fprintf(fp,"\n");
   fflush(fp);
   for (h=0;h<18;h++)
      count[h]=0;
   fprintf(fp,"# (#factors:)");
   for (list_ptr= db->list;list_ptr!=db->next_sigma;list_ptr++)
      if (list_ptr->fact_addr)
         if (list_ptr->no_factors < 17)
            count[list_ptr->no_factors]++;
         else
            count[17]++;
      else
         count[0]++;
   k=1;
   i=count[1];
   for (h=1;h<=16;h++,i+=count[h])
      if (h <= 2)
      {  fprintf(fp," %u(%u)",i,h);
         k += k;
         i=0;
      }
      else if (h==k)
      {  fprintf(fp," %u(%u-%u)",i,k/2+1,k);
         k += k;
         i=0;
      }
   fprintf(fp," %u(%u-)",count[17],k/2+1);
   fprintf(fp," %u(?)\n",count[0]);
   fflush(fp);
}


int save_heap(char * filename)
{
   unsigned  no;
   unsigned char  bytes[4];
   void * db_info[16];
   FILE *gp;
   if (flags&32)
   {  flags |= 64;
      return 63;
   }
   if (!db)  error_stop(7,"in save_heap: ");
   if (!(gp=fopen(filename,"w")))  return 1;
   if (size_info(db_info) < 0)
      return 2;
   no=(unsigned)db_info[0] & (1<<26)-1;   no |= 9<<26;   db_info[0]= (void*)no;
   for (no=0;no<4;no++)
      bytes[no]= (unsigned)db_info[0]>>(8*no) & 255;
   if (compact)
      bytes[3] |= 1<<7;
   if (4 != fwrite (bytes, 1, 4, gp))
      return 2;
   if (compact)
   {  unsigned  k;
      static long  len, *base;
      info  *taddr;
      longint  *prime_ptr, *next_ptr;
      taddr = (info *) malloc( sizeof(info) * db->nopri );
      if (!taddr)
         error_stop(8,"in save_heap: ");
      no = db->next_prime - db->longprime;
      prime_ptr = (longint *) malloc( sizeof(longint) * no );
      if (!prime_ptr)
         error_stop(8,"in save_heap: ");
      next_ptr= prime_ptr;
      for (k=1;k<db->nopri;k++)
      {  taddr[k] = db->table[k];
         taddr[k].pri_addr = (longint *) next_ptr;
         base= (long *) db->table[k].pri_addr;
         len= *base;
         ztoul(base, next_ptr+1, &len);
         *next_ptr= len;
         next_ptr += len+1;
      }
      db_info[4] = (void *)(next_ptr - prime_ptr);
      if (9 != fwrite (db_info+1, sizeof(void *), 9, gp))
         return 2;
      if (db->nopri != fwrite (taddr, sizeof(info), db->nopri, gp))
      {  free(prime_ptr);  free(taddr);
         return 3;
      }
      no= next_ptr - prime_ptr;
      if (no != fwrite (prime_ptr, sizeof(longint), no, gp))
      {  free(prime_ptr);  free(taddr);
         return 3;
      }
      free(prime_ptr);
      free(taddr);
   }
   else
   {  if (9 != fwrite (db_info+1, sizeof(void *), 9, gp))
         return 2;
      if (db->nopri != fwrite (db->table, sizeof(info), db->nopri, gp))
         return 3;
      no= (unsigned)db_info[4];
      if (no != fwrite (db->longprime, sizeof(longint), no, gp))
         return 3;
   }
   no= (unsigned)db_info[6];
   if (no != fwrite (db->list, sizeof(vect), no, gp))
      return 3;
   no= (unsigned)db_info[8];
   if (no != fwrite (db->powerheap, sizeof(pri_power), no, gp))
      return 3;
   fclose(gp);
   flags &= ~1;
   return 0;
}


int info_heap(char * filename, unsigned size[16])
{
   unsigned  h, i, j, k, no;
   unsigned char  bytes[4];
   void *db_info[16];
   FILE *gp = fopen(filename,"r");
   if (!gp)  return 1;
   if (4 != fread (bytes, 1, 4, gp))
      return  2;
   h=0;
   for (no=4;no--;)
   {  h <<= 8;
      h |= bytes[no];
   }
   size[8]= h & (1<<20)-1;
   size[6]= (size[8]>>5)/13;
   size[7]= (size[8]>>5) % 13 + 1;
   size[8] &= 31;
   h >>= 20;
   j= 1 << (4+(1+(h&3) &3));
   size[9] = j;
   h>>=2;
   i= 1 << (4+(1+(h&3) &3));
   size[10] = i;
   h>>=2;
   no = h>>2 & 15;
   size[12] = h>>6 &3;
   h= 1 << (4+(1+(h&3) &3));
   size[11] = h;
   if (!no)
      no=9;
   size[0] = no+1;
   if (j == 8*sizeof(void *))
   {
      if (no != fread (db_info+1, sizeof(void *), no, gp))
         return  2;
   }
   else if (j < 8*sizeof(void *))
   {  for (k=1;k<=no;k++)
      {  db_info[k]= (void *) 0;
         if (1 != fread (db_info+k, j/8, 1, gp))
            return  2;
      }
   }
   else
   {  unsigned long  temp[32];
      for (k=1;k<=no;k++)
      {  if (1 != fread (temp, j/8, 1, gp))
            return  2;
         db_info[k]= (void *) temp[0];
      }
   }
   fclose(gp);
   size[1]= (unsigned)db_info[2];
   size[2]= (unsigned)db_info[4];
   size[3]= (unsigned)db_info[6];
   size[4]= (unsigned)db_info[8];
   size[5]= (unsigned)db_info[9];
   return 0;
}


int stretch(void * arbi, unsigned no, unsigned c,
            unsigned sz_old[], unsigned sz_new[])
{  unsigned  h, i, j, k, l, m, n, mgap, kgap;
   unsigned  char scr[16];
   k= m= 0;
   for (j=0;j<c;j++)
   {  if (sz_old[j] > 16 || sz_new[j] > 16 || !sz_old[j] || !sz_new[j])
         return  1;
      m += sz_old[j];
      k += sz_new[j];
   }
   mgap= round_up_2power(m)-m;
   kgap= round_up_2power(k)-k;
   m += mgap;
   k += kgap;
   for (i=no;i--;)
   {
      n=m; /** -mgap **/
      l=k; /** -kgap **/
      for (j=c;j--;)
      {
         n -= sz_old[j];
         if (sz_old[j]%4)
            n -= 4-sz_new[j];
         for (h=0;h<sz_new[j];h++)
            scr[h]= 0;
#ifdef  ALIGN_ENDIANNESS_OK
         if (sz_old[j] == sizeof(void*))
            *((void**) scr)= *((void**) ((unsigned char*)arbi+m*i+n));
         else if (sz_old[j] == sizeof(unsigned))
            *((unsigned*) scr)= *((unsigned*) ((unsigned char*)arbi+m*i+n));
         else if (sz_old[j] == sizeof(unsigned long))
            *((unsigned long*) scr) = *((unsigned long*) ((unsigned char*)arbi+m*i+n));
         else
#endif
            for (h=0;h<sz_old[j];h++) 
               *(scr+h) = *((unsigned char*)arbi+m*i+n+h);
         l -= sz_new[j];
         if (sz_new[j]%8)
            l -= 8-sz_new[j];
#ifdef  ALIGN_ENDIANNESS_OK
         if (sz_new[j] == sizeof(void*))
            *((void**) ((unsigned char*)arbi+k*i+l)) = *((void**) scr);
         else if (sz_new[j] == sizeof(unsigned))
            *((unsigned*) ((unsigned char*)arbi+k*i+l)) = *((unsigned*) scr);
         else if (sz_new[j] == sizeof(unsigned long))
            *((unsigned long*) ((unsigned char*)arbi+k*i+l)) = *((unsigned long*) scr);
         else
#endif
            for (h=0;h<sz_new[j];h++) 
               *((unsigned char*)arbi+k*i+l+h) = *(scr+h);
      }
   }
   return 0;
}


int load_heap(char * filename)
{
   unsigned  h, i, j, k, no, is_compact;
   unsigned char  bytes[4];
   void * db_info[16];
   vect * list_ptr;
   info * taddr;
   pri_power  *heap_ptr;
   longint  *prime_ptr;
   FILE *gp = fopen(filename,"r");
   if (!gp)  return 1;
   if (4 != fread (bytes, 1, 4, gp))
      return  15;
   h=0;
   for (no=4;no--;)
   {  h <<= 8;
      h |= bytes[no];
   }
   h >>= 20; /* (32*(year*13+(month-1))+day) */
   j= 1 << (4+(1+(h&3) &3));
   if (j > 8*sizeof(void *) || j%8)
      return 12;
   h>>=2;
   i= 1 << (4+(1+(h&3) &3));
   if (i > 8*sizeof(longint) || i%8)
      return 13;
   h>>=2;
   no = h>>2 & 15;
   is_compact = h>>7 & 1;
   h= 1 << (4+(1+(h&3) &3));
   if (h > 8*sizeof(unsigned) || h%8)
      return 14;
   if (!no)
      no=9;
   if (j == 8*sizeof(void *))
   {  if (no != fread (db_info+1, sizeof(void *), no, gp))
         return  2;
   }
   else
   {  for (k=1;k<=no;k++)
      {  db_info[k]= (void *) 0;
         if (1 != fread (db_info+k, j/8, 1, gp))
            return  2;
      }
   }
   if (!db)
   {  if ((no=(unsigned)db_info[2])>table_size) table_size=no;
      if ((no=(unsigned)db_info[4])>prime_heapsize) prime_heapsize=no+(is_compact?no/4:0);
      if ((no=(unsigned)db_info[6])>factorisations) factorisations=no;
      if ((no=(unsigned)db_info[8])>power_heapsize) power_heapsize=no;
      db= create_db(table_size,prime_heapsize,factorisations,power_heapsize);
   }
   else if ((unsigned)db_info[2] > table_size)
      return 3;
   else if ((unsigned)db_info[4] > prime_heapsize)
      return 4;
   else if ((unsigned)db_info[6] > factorisations)
      return 5;
   else if ((unsigned)db_info[8] > power_heapsize)
      return 6;
   if ((unsigned)db_info[9] > MAXFACTORS)  return 7;
   if ((8*sizeof(void *)) % j)
      return 12;
   if ((8*sizeof(longint)) % i)
      return 13;
   if ((8*sizeof(unsigned)) % h)
      return 14;
   j /= 8; i /= 8;  h /= 8;
   if (!is_compact && (j != sizeof(void *) || i != sizeof(longint) || h != sizeof(unsigned)))
      return 16;
   flags &= ~1;
   no= (unsigned)db_info[2];
   k= round_up_2power(2*j+2*h);
   if (no != fread (db->table, k, no, gp))
      return 8;
   if (k != sizeof(info))
   {  unsigned sz_old[4] = { j, h, j, h };
      unsigned sz_new[4] = { sizeof(longint*), sizeof(unsigned),
                             sizeof(struct s_v *), sizeof(unsigned) };
      stretch(db->table,no,4,sz_old, sz_new);
   }   
   if (is_compact)
   {  prime_ptr = (longint *) malloc( sizeof(longint) * prime_heapsize );
      if (!prime_ptr)
         error_stop(8,"in load_heap: ");
   }
   else
      prime_ptr= db->longprime;
   no= (unsigned)db_info[4];
   if (no != fread (prime_ptr, i, no, gp))
      return 9;
   if (i != sizeof(longint))
   {  unsigned sz_old[1] = { i };
      unsigned sz_new[1] = { sizeof(longint) };
      stretch(prime_ptr,no,1,sz_old,sz_new);
   }   
   no= (unsigned)db_info[6];
   k= round_up_2power(j+h);
   if (no != fread (db->list, k, no, gp))
      return 10;
   if (k != sizeof(vect))
   {  unsigned sz_old[2] = { j, h };
      unsigned sz_new[2] = { sizeof(struct s_p *), sizeof(unsigned) };
      stretch(db->list,no,2,sz_old,sz_new);
   }   
   no= (unsigned)db_info[8];
   k= round_up_2power(j+h);
   if (no != fread (db->powerheap, k, no, gp))
      return 11;
   if (k != sizeof(pri_power))
   {  unsigned sz_old[2] = { j, h };
      unsigned sz_new[2] = { sizeof(struct s_i *), sizeof(unsigned) };
      stretch(db->powerheap,no,2,sz_old,sz_new);
   }   
   fclose(gp);
   db->nopri= (unsigned)db_info[2];
   if (is_compact)
   {  static long  *base=0;
      long  len, *next_ptr, *old_ptr, mask;
      old_ptr= next_ptr= (long*) prime_ptr;
      db->next_prime = db->longprime;
      for (taddr=db->table+1;taddr != db->table+db->nopri;taddr++)
      {  taddr->pri_addr = db->next_prime;
         if (i != sizeof(longint))
         {  unsigned  b, w;
            len= *old_ptr;
            mask= (1UL<<(8*i))-1;
            b=i*(old_ptr==next_ptr);  w=1;
            for (k=1+(old_ptr==next_ptr);k<=len;k++,b+=i)
            {  if (b == sizeof(longint))
                  b -= sizeof(longint),  w++;
               if (!b)
                  *(next_ptr+w)  &= ~mask;
               *(next_ptr+w)  |= *(old_ptr+k) << (8*b) ;
            }
            old_ptr += len+1;
            if (len>1) /* can len be 0 ? */
               *next_ptr = 1+ (len-1)/(sizeof(longint)/i);
         }
         len= *next_ptr;
         zultoz(next_ptr+1, len, &base);
         if (db->next_prime + 1 + *base > db->longprime + prime_heapsize)
         {  free(prime_ptr);
            return 4;
         }
         *db->next_prime++ = *base;
         for (k=1;k<=*base;k++)
            *db->next_prime++ = *(base+k);
         next_ptr += len+1;
      }
      free(prime_ptr);
   }
   else
      db->next_prime = db->longprime + (unsigned)db_info[4];
   k= round_up_2power(j+h);
   for (taddr=db->table;taddr != db->table+db->nopri;taddr++)
   { 
      if (!is_compact)
         taddr->pri_addr = db->longprime + ((unsigned char *) taddr->pri_addr -
                                               (unsigned char *) db_info[3])/i;
      if (taddr->sigma)
         taddr->sigma = db->list + ((unsigned char *) taddr->sigma -
                                               (unsigned char *) db_info[5])/k;
   }
   db->next_sigma = db->list + (unsigned)db_info[6];
   k= round_up_2power(j+h);
   for (list_ptr = db->list;list_ptr != db->next_sigma;list_ptr++)
      if (list_ptr->fact_addr)
         list_ptr->fact_addr = db->powerheap + ((unsigned char *)
                          list_ptr->fact_addr - (unsigned char *) db_info[7])/k;
   db->next_power = db->powerheap + (unsigned)db_info[8];
   k= round_up_2power(2*j+2*h);
   for (h=0,heap_ptr= db->powerheap;h<(unsigned)db_info[8];heap_ptr++,h++)
      heap_ptr->base = db->table + ((unsigned char *) heap_ptr->base -
                                              (unsigned char *) db_info[1])/k;
   return 0;
}


int merge_heap(char * filename)
{
   int  i;
   database  *other, *safe=0;
   if (!db)  error_stop(7,"in merge_heap: ");
   other= create_db(table_size, prime_heapsize, factorisations, power_heapsize);
   if (!other)
      return  8;
   safe= db;
   access_db(other);
   if (i=load_heap(filename))
   {  access_db(safe);
      delete_db(other);
      return i;
   }
   access_db(safe);
   if (i=merge_db(other))
   {  delete_db(other);
      return i;
   }
   delete_db(other);
   return  0;
}


int check_heap(unsigned probprime_tests, unsigned check_mask, unsigned check_param)
{
   int  h, i, j, k, flag=0;
   static long  *one=0, *d=0, *n=0, *base, *fase;
   pri_power  *heap_ptr;
   vect  *list_ptr;
   info   *taddr;
   if (!db)
      return 0;
   check_mask ^= 1023-8-4; /* for backward-compatibility */
   zintoz(1,&one);
   base= one;
   if (db->nopri > table_size)
   {  fprintf(stderr,"prime table overflow: %u of %u allocated\n",
              db->nopri,table_size);
      flag |= 1<<20;
   }
   if (check_mask&1)
   for (h=1;h<db->nopri;h++)
   {  fase = base;
      base = (long *) db->table[h].pri_addr;
      list_ptr = db->table[h].sigma;
      if (base < (long *) db->longprime || base >= (long *) db->next_prime)
      {  fprintf(stderr,"primeaddr not in prime_heap at table index %u\n",h);
         flag |= 1<<6;
         continue;
      }
      else if (*base <= 0  ||  base + *base >= (long *) db->next_prime)
      {  fprintf(stderr,"prime juts prime_heap at table index %u\n",h);
         flag |= 1<<5;
         continue;
      }
      else if (!list_ptr)
      {  if (db->table[h].maxexpo)
         {  fprintf(stderr,"missing pointer into sigma list at table index %u\n",h);
            flag |= 1<<10;
         }
         continue;
      }
      else if (list_ptr < db->list || list_ptr > db->next_sigma)
      {  fprintf(stderr,"factorization not in list at table index %u\n",h);
         flag |= 1<<8;
         continue;
      }
      else if (list_ptr + db->table[h].maxexpo-1 >= db->next_sigma)
      {  fprintf(stderr,"maxexpo juts list at table index %u\n",h);
         flag |= 1<<7;
         continue;
      }
      if (zcompare(base,fase) <= 0)
      {  fprintf(stderr,"primes in table not strictly ordered at table index %u\n",h);
         flag |= 1<<9;
         continue;
      }
#ifndef  ONE_UP
      zintoz(1,&d);
#else
      zzero(&d);
#endif
      if (check_mask&2)
      for (i=1;i<=db->table[h].maxexpo;i++,list_ptr++)
      {
#ifndef  ONE_UP
         zmulin(base,&d);
         zadd(d,one,&d);
#else
         zadd(d,one,&d);
         zmulin(base,&d);
         zsub(d,one,&d);
#endif
         if (heap_ptr= list_ptr->fact_addr)
         {  if (heap_ptr < db->powerheap || heap_ptr >= db->next_power)
            {  fprintf(stderr,"%uth fact_addr not in prime-power heap at table index %u\n",i,h);
               flag |= 1<<4;
               continue;
            }
            else if (heap_ptr + list_ptr->no_factors > db->next_power)
            {  fprintf(stderr,"%uth fact_addr juts prime-power heap at table index %u\n",i,h);
               flag |= 1<<3;
               continue;
            }
            if (list_ptr->no_factors <= 0  ||  list_ptr->no_factors > MAXFACTORS)
            {  fprintf(stderr,"%u prime-powers in factorization of table index %u and expo %u\n", list_ptr->no_factors, h,i);
               flag |= 1<<3;
               continue;
            }
            zintoz(1,&n);
            for (j=0;j<list_ptr->no_factors;j++,heap_ptr++)
            {  taddr = heap_ptr->base;
               if (!taddr)
               {  fprintf(stderr,"%uth prime_factor undefined for prime-power of table index %u and expo %u\n", j+1, h,i);
                  flag |= 1;
                  continue;
               }
               if (taddr < db->table+1 || taddr >= db->table+db->nopri)
               {  fprintf(stderr,"%uth prime_factor not in table for factorization of table index %u and expo %u\n",
                          j+1, h,i);
                  flag |= 1<<2;
                  continue;
               }
               fase = (long *) taddr->pri_addr;
               if (fase < (long *) db->longprime || fase >= (long *) db->next_prime)
               {  fprintf(stderr,"%uth prime_factor not in primeheap for factorization of table index %u and expo %u\n",j+1,h,i);
                  flag |= 1<<1;
                  continue;
               }
               if (*fase <= 0 || *fase > MAX_PRIME_LENGTH/sizeof(longint))
               {  fprintf(stderr,"%uth prime_factor has illegal or untrusted size for factorization of table index %u and expo %u: %lu\n",j+1,h,i,*fase);
                  flag |= 1<<11;
                  continue;
               }
               for (k=1;k<=heap_ptr->expo;k++)
                  zmulin(fase,&n);
               if ((check_mask&8)  && taddr->maxexpo < heap_ptr->expo)
               {  fprintf(stderr,"warning: expo %d > %d for ",
                          heap_ptr->expo, taddr->maxexpo);
                  zfwrite(stderr, fase, DEFAULT_LINE_LEN,"","");
                  fprintf(stderr,"\n");
               }
            }
            if (j<list_ptr->no_factors)   /* How can this happen HERE ? */
               db->table[h].sigma[i-1].fact_addr = (pri_power *) 0; 
            else if (zcompare(n,d))
            {  fprintf(stderr,"error at table index %u   prime: ",h);
               zfwrite(stderr,base,DEFAULT_LINE_LEN,"","");
               fprintf(stderr,"   Expo= %d\n",i);
               fprintf(stderr,"heap_addr = %8lx\n",heap_ptr-db->powerheap);
               fprintf(stderr,"number of factors = %u\n   product=",
                       list_ptr->no_factors);
               zfwriteln(stderr,n);
               flag |= 1<<12;
            }
         }
         else if (check_mask&4)
         {  fprintf(stderr,"warning: no factorization: expo %d for ",i);
            zfwrite(stderr, base, DEFAULT_LINE_LEN,"","");
            fprintf(stderr,"\n");
         }
      }
   }
   if (check_mask&16)
   {  j=0;
      for (list_ptr=db->list;list_ptr!=db->next_sigma;list_ptr++)
         if (list_ptr->fact_addr)
            j+= list_ptr->no_factors;
      if (db->next_power != db->powerheap+j)
      {  fprintf(stderr,"error in heap:  prime_powers=%lu  expected=%u\n",
                        db->next_power-db->powerheap,j);
         flag |= 1<<19;
      }
#ifdef  FAST_CHECK
      unsigned char  *cc = calloc((j=db->next_power-db->powerheap), 1);
      for (list_ptr=db->list;list_ptr!=db->next_sigma;list_ptr++)
      {  k= list_ptr->fact_addr - db->powerheap;
         if (k < j)
         {  if (cc[k]) 
               fprintf(stderr,"warning: multi-times used heap_addr = %8lx\n",
                       k+db->powerheap);
            if (!list_ptr->no_factors)
            {  fprintf(stderr,"no of factors is 0 at heap_addr = %8lx\n",
                       k+db->powerheap);
               flag |= 1<<18;
            }
            else
               cc[k] = list_ptr->no_factors;
         }
      }
      for (k=0,heap_ptr=db->powerheap;heap_ptr<db->next_power;heap_ptr+=j)
      {  j= cc[k];
         if (!j)
            break;
         for (h=1;h<j;h++)
         {  if ((heap_ptr+h)->base <= (heap_ptr+h-1)->base)
            {  fprintf(stderr,"prime power base not strictly increasing at heap_addr = %8lx\n",
                       heap_ptr+h-db->powerheap);
               flag |= 1<<17;
            }
            if (cc[k+h])
               fprintf(stderr,"warning: alignment error at heap_addr = %8lx\n",
                       k+h+db->powerheap);
         }
         k += j;
      }
      free(cc);
#else
      for (heap_ptr=db->powerheap;heap_ptr<db->next_power;)
      {  k = 0;
         j = 1;
         for (list_ptr=db->list;list_ptr!=db->next_sigma;list_ptr++)
            if (heap_ptr==list_ptr->fact_addr)
            {  k++;
               j= list_ptr->no_factors;
               if (!j)
               {  fprintf(stderr,"no of factors is 0 at heap_addr = %8lx\n",
                          heap_ptr);
                  flag |= 1<<18;
               }
            }
         if (!k)
         {  fprintf(stderr,"unused heap_addr = %8lx\n",
                    heap_ptr-db->powerheap);
            flag |= 1<<19;
         }
         else if (k > 1)
            fprintf(stderr,"warning: %u-times used heap_addr = %8lx\n",
                    k,heap_ptr-db->powerheap);
         if (!j)
            break;
         while( heap_ptr++, --j )
         {  if (heap_ptr->base <= (heap_ptr-1)->base)
            {  fprintf(stderr,"prime power base not strictly increasing at heap_addr = %8lx\n",
                           heap_ptr-db->powerheap);
               flag |= 1<<17;
            }
         }
      }
#endif
   }
   if (!(flag & 1<<19) && (check_mask&32))
   {  unsigned  *count;
      count = (unsigned *) calloc(table_size, sizeof(unsigned));
      for (heap_ptr=db->powerheap;heap_ptr!=db->next_power;heap_ptr++)
         count[heap_ptr->base - db->table]++;
      j=0;
      for (h=1;h<db->nopri;h++)
         if (db->table[h].links != count[h])
         {  fprintf(stderr,"links for table index %u differ from count: %u %u\n",
                           h,db->table[h].links,count[h]);
            flag |= 1<<21;
         }
         else if ((check_mask&256) && !count[h])
         {/*fprintf(stderr,"warning: table index %u unused for prime ", h);
            zfwriteln(stderr,db->table[h].pri_addr);  **/
            i=h;  j++;
         }
      free(count);
      if (j && (check_mask&256))
      {
         fprintf(stderr,"warning: %u unrefered primes in table;"
                        " largest at index %u: ",j,i);
         zfwriteln(stderr,db->table[i].pri_addr);
      }
   }
   if (check_mask&64)
   {  j=0;
      for (h=1;h<db->nopri;h++)
         j+= db->table[h].maxexpo;
      if (db->next_sigma != db->list+j)
      {  fprintf(stderr,"error in list:  sigma_entries=%lu  expected=%u\n",
                        db->next_sigma-db->list,j);
         flag |= 1<<23;
      }
#ifdef  FAST_CHECK
      unsigned char  *cc = calloc((j=db->next_sigma-db->list), 1);
      for (h=1;h<db->nopri;h++)
      {  if (db->table[h].maxexpo)
         {  k= db->table[h].sigma - db->list;
            if (db->table[h].sigma && k < j)
            {  if (cc[k]) 
                  fprintf(stderr,"warning: multi-times used heap_addr = %8lx\n",k);
               if (!db->table[h].maxexpo)
               {  fprintf(stderr,"max expo is 0 at table index %u\n",
                          h);
                  flag |= 1<<22;
               }
               else
                  cc[k]= db->table[h].maxexpo;
            }
         }
      }
      for (k=0,list_ptr=db->list;list_ptr<db->next_sigma;list_ptr+=j)
      {  j= cc[k];
         if (!j)
            break;
         for (h=1;h<j;h++)
            if (cc[k+h])
               fprintf(stderr,"warning: alignment error at heap_addr = %8lx\n",
                       k+h+db->powerheap);
         k += j;
      }
      free(cc);
#else
      for (list_ptr=db->list;list_ptr<db->next_sigma;list_ptr+=j)
      {  k = 0;
         j = 1;
         for (h=1;h<db->nopri;h++)
            if (list_ptr == db->table[h].sigma  &&  db->table[h].maxexpo)
            {  k++;
               j= db->table[h].maxexpo;
               if (!j)
               {  fprintf(stderr,"max expo is 0 at table index %u\n",
                          h);
                  flag |= 1<<22;
               }
            }
         if (!k)
         {  fprintf(stderr,"unused list_addr = %8lx\n",
                    list_ptr-db->list);
            flag |= 1<<23;
         }
         else if (k > 1)
            fprintf(stderr,"warning: %u-times used list_addr = %8lx\n",
                    k,list_ptr-db->list);
         if (!j)
            break;
      }
#endif
   }
   h = db->next_prime - db->longprime;
   if (check_mask&128)
#ifdef  FAST_CHECK
   {  unsigned  *index = calloc((j=db->next_prime-db->longprime),
                                sizeof(unsigned));
      for (k=1;k<db->nopri;k++)
         if ((h=db->table[k].pri_addr-db->longprime) < j)
            index[h]=k;
#endif
      for (k=1,h=0;h<db->next_prime-db->longprime;h+=db->longprime[h]+1)
      {  if (db->longprime[h] > MAX_PRIME_LENGTH/sizeof(longint))
         {  fprintf(stderr,"at addr = %x is non trusted number of length %u\n",
                    h,*(db->longprime+h)*sizeof(longint));
            flag |= 1<<16;
         }
         else
         {  j= !is_valid(db->longprime+h) ||
               !is_prime(db->longprime+h,probprime_tests);
            if (j)
            {  fprintf(stderr,"at addr = %x is non-prime: ",h);
               if (!db->longprime[h])
                  fprintf(stderr,"0\n");
               else
                  zfwriteln(stderr,db->longprime+h);
               flag |= 1<<13;
            }
         }
#ifdef  FAST_CHECK
         if (!(j=index[h]))
            j=db->nopri;
#else
         do {
            for (j=k;j<db->nopri;j++)
               if (!zcompare(db->longprime+h,db->table[j].pri_addr))
                  break;
            if (j < db->nopri  ||  k == 1)
               break;
            k=1;
         } while(1);
#endif
         if (j < db->nopri)
            k= j++;
         else
         {  fprintf(stderr,"prime not in table: ");
            if (!db->longprime[h])
               fprintf(stderr,"0\n");
            else if (db->longprime[h] <= MAX_PRIME_LENGTH/sizeof(longint))
               zfwriteln(stderr,db->longprime+h);
            else
            {  base= db->next_prime;
               for (j=1;j<db->nopri;j++)
                  if (db->table[j].pri_addr > db->longprime+h &&
                      db->table[j].pri_addr < (longint *) base)
                     base= db->table[k=j].pri_addr;
               db->longprime[h] = (longint *) base - db->longprime+h -1;
               fprintf(stderr,"\nprime length set to %u\n",db->longprime[h]*sizeof(long));
            }
            flag |= 1<<15;
         }
      }
#ifdef  FAST_CHECK
      free(index);
   }
#endif
   if (db->longprime+h != db->next_prime)
   {  fprintf(stderr,"next_prime too small %lu\n",db->longprime+h-db->next_prime);
      flag |= 1<<14;
   }
   return  flag;
}


unsigned  change_heap_entry_type()
{
   return  entry= !entry;
}


unsigned  change_longint_compact_type()
{
   return  compact= !compact;
}


int search_fact(unsigned  bits)
{
   int  h, i, j, k=0;
   static long  *base, *fase;
   pri_power  *heap_ptr;
   info   *taddr;
   char  buffer[1024];
   if (!db)  error_stop(7,"in search_fact: ");
   for (h=2;h<db->nopri;h++)
   {  base = (long *) db->table[h].pri_addr;
      for (i=1;i<=db->table[h].maxexpo;i++)
      {  if (heap_ptr=db->table[h].sigma[i-1].fact_addr)
         {  j= db->table[h].sigma[i-1].no_factors;
            if (j > k)  k=j;
            for (;j--;heap_ptr++)
            {  if (j==1 && (taddr = heap_ptr->base))
               {  fase = (long *) taddr->pri_addr;
                  if (z2log(fase) >= bits)
                  {  zfwriteln(stderr,base);
                     write_factoring(h,i,buffer);
                     fprintf(stderr,"(%lu)=%s\n",z2log(fase),buffer);
                  }
               }
            }
         }
      }
   }
   return  k;
}


int delete_factoring(unsigned index, unsigned me)
{
   unsigned  h, i;
   vect  *list_ptr;
   pri_power  *heap_ptr;
   if (!db)  error_stop(7,"in delete_factoring: ");
   if (index <= 0 || index >= db->nopri)
      error_stop(1,"in delete_factoring: ");
   if (!me || me > db->table[index].maxexpo)
      return -1;
   list_ptr = db->table[index].sigma+me-1;
   if (!(heap_ptr=list_ptr->fact_addr) || !(h = list_ptr->no_factors))
      return  0;
   for (i=0;i<h;i++,heap_ptr++)
      heap_ptr->base->links --;
   for (;heap_ptr != db->next_power;heap_ptr++)
      *(heap_ptr-h) = *heap_ptr;
   db->next_power -=h;
   heap_ptr=list_ptr->fact_addr;
   list_ptr->fact_addr = (pri_power *) 0;
   for (list_ptr = db->list; list_ptr != db->next_sigma; list_ptr++)
      if (list_ptr->fact_addr  &&  list_ptr->fact_addr >= heap_ptr)
         list_ptr->fact_addr -= h;
   flags |= 1;
   return 0;
}


int next_refer(unsigned index, unsigned *start, unsigned *me)
{
   unsigned  i;
   pri_power  *heap_ptr;
   info   *taddr;
   if (!db)  error_stop(7,"in next_refer: ");
   if (index <= 0 || index >= db->nopri)
      error_stop(1,"in next_refer: ");
   if (*start <= 0 || *start >= db->nopri)  return 0;
   taddr = db->table+index;
   do {
      while ((*me+=1) <= db->table[*start].maxexpo)
         if (heap_ptr=db->table[*start].sigma[*me-1].fact_addr)
            for (i=db->table[*start].sigma[*me-1].no_factors;i;i--,heap_ptr++)
                if (heap_ptr->base == taddr)
                   return  1;
      start++;
      *me=0;
   } while (*start != db->nopri);
   return 0;
}


unsigned get_prime_count(unsigned index)
{
   if (!db)  error_stop(7,"in get_prime_count: ");
   if (index <= 0 || index >= db->nopri)
      error_stop(1,"in get_prime_count: ");
   return  db->table[index].links;
}


int delete_prime(unsigned index)
{
   unsigned  h, i;
   info *taddr;
   longint  *prime_ptr;
   pri_power  *heap_ptr;
   if (!db)  error_stop(7,"in delete_prime: ");
   if (index <= 0 || index >= db->nopri)
      error_stop(1,"in delete_prime: ");
   if  (db->table[index].links)
      return  1;
   if (h=db->table[index].maxexpo)
      if ((int)-h  !=  alloc_factoring(index,(int)-h))
         return  2;
   prime_ptr = db->table[index].pri_addr;
   flags |= 32;  /*** begin of critical part ***/
   for (i=index+1;i<db->nopri;i++)
      db->table[i-1] = db->table[i];
   taddr= db->table+index;
   db->nopri--;
   for (heap_ptr=db->powerheap;heap_ptr != db->next_power;heap_ptr++)
      if (heap_ptr->base >=taddr)
         heap_ptr->base -= 1;
   h=  *prime_ptr + 1;
   for (i=1;i<db->nopri;i++)
      if (db->table[i].pri_addr >= prime_ptr)
         db->table[i].pri_addr -= h;
   db->next_prime -= h;
   for (;prime_ptr != db->next_prime;prime_ptr++)
      *prime_ptr = *(prime_ptr+h);
   flags &= ~32;  /*** end of critical part ***/
   do_update_indices(-(int)i);
   flags |= 1;
   return  0;
}


int load_oldheap(char * filename)
{
   unsigned  db_info[8], h, i, j, k;
   vect *list_ptr;
   pri_power  *heap_ptr;

union factor { unsigned no_factors; union i_info *table_addr; longint pri_expo; };
union i_info { unsigned maxexpo; longint *pri_addr; union factor  *fac_addr; }
   *iaddr[table_size]; 

   FILE *gp = fopen(filename,"r");
   if (!gp)  return 1;
   if (sizeof(unsigned) != 4 || sizeof(void *) != 4 || sizeof(longint) != 4)
      return 6;
   fread (db_info, sizeof(unsigned), 8, gp);
   if (db_info[0]>>20)  return 2;
   if (db_info[5]+1 > table_size)  return  3;
   if (db_info[2] > 2*table_size+factorisations)  return 3;
   if (db_info[4] > prime_heapsize)  return 4;
   if (!db)
      db= create_db(table_size,prime_heapsize,factorisations,power_heapsize);
   db->next_sigma= db->list;
   i=0;
   for (j=0,k=1;j<db_info[2];k++)
   {
      iaddr[k]= (union i_info *) db_info[1] + 1 + j;
      if (1 != fread (&db->table[k].maxexpo, sizeof(unsigned), 1, gp))
         return  6;
      if (1 != fread (&db->table[k].pri_addr, sizeof(longint *), 1, gp))
         return  6;
      db->table[k].pri_addr += db->longprime - (longint *) db_info[3];
      j += 2;
      db->table[k].sigma = db->table[k].maxexpo ? db->next_sigma : (vect *) 0;
      db->table[k].links = 0;
      for (h=0;h<db->table[k].maxexpo;h++)
      {
         if (1 != fread (&db->next_sigma->fact_addr, sizeof(pri_power *), 1, gp))
            return  6;
         if (db->next_sigma->fact_addr)
            i++;
         db->next_sigma->no_factors=0;
         db->next_sigma++;
      }
      j += h;
   }
   if (k != db_info[5]+1)
      error_stop(10,"in load_old_heap: ");
   db->nopri = k;
   if (db_info[7]-i > 2*power_heapsize)  return 4;
   if (db_info[4] != fread (db->longprime, sizeof(longint), db_info[4], gp))
      return 7;
   db->next_prime= db->longprime + db_info[4];
   db->next_power= db->powerheap;
   for (j=0;j<db_info[7];)
   {
      for (list_ptr = db->list;list_ptr != db->next_sigma ;list_ptr++)
         if (list_ptr->fact_addr  &&  !list_ptr->no_factors  &&
             (union factor *) list_ptr->fact_addr == (union factor *) db_info[6] + j)
            break;
      if (list_ptr == db->next_sigma)
         error_stop(11,"in load_old_heap: ");
      if (1 != fread (&list_ptr->no_factors, sizeof(unsigned), 1, gp))
         return  8;
      j++;
      if (!list_ptr->no_factors  ||  list_ptr->no_factors > MAXFACTORS)
         error_stop(6,"in load_old_heap: ");
      for (h=0;h<list_ptr->no_factors;h++)
      {
         if (1 != fread(&db->next_power->base, sizeof (info *), 1, gp))
            return  8;
         for (i=1;i<db->nopri;i++)
            if ((union i_info*) db->next_power->base == iaddr[i])
            {
               db->next_power->base = db->table+i;
               break;
            }
         if (i == db->nopri)
            error_stop(12,"in load_old_heap: ");
         if (1 != fread(&db->next_power->expo, sizeof (unsigned), 1, gp))
            return  8;
         db->next_power++;
      }
      list_ptr->fact_addr = db->next_power - h;
      j += 2*h;
   }
   fclose(gp); 
   for (heap_ptr=db->powerheap;heap_ptr!=db->next_power;heap_ptr++)
      heap_ptr->base->links++;
   flags &= ~1;
   return 0;
}


database * create_db(unsigned tabsize, unsigned primsize,
               unsigned factsize, unsigned powersize)
{
   unsigned long  k;
   database * other;

   k = sizeof(database);
   k+= tabsize * sizeof(info);
   k+= primsize * sizeof(longint);
   k+= factsize * sizeof(vect);
   k+= powersize * sizeof(pri_power);
   if (!(other = (database *) malloc( k )))
      return (database*) 0;
   other->table = (info *) (other + 1);
   other->longprime = (longint*) (other->table + tabsize);
   other->list = (vect*) (other->longprime + primsize);
   other->powerheap = (pri_power *) (other->list + factsize);
   other->nopri=1;  /* first table-entry unused */
   other->next_prime = other->longprime;
   other->next_sigma = other->list;
   other->next_power = other->powerheap;
   other->total_size = k;
   other->upd_count = 0; /* following 4 upd-members need no initialization */
   return  other;
}


void delete_db(database *other)
{
   free(other);
}


database *  access_db(database *other)
{
   database *safe= db;
   if (other)
   {  db = other;
      table_size= (info *) db->longprime - db->table;
      factorisations= (vect *) db->powerheap - db->list;
      prime_heapsize= (longint *) db->list - db->longprime;
      power_heapsize= (db->total_size - sizeof(database))/sizeof(pri_power)
                                     -(db->powerheap - (pri_power *) db->table);
   }
   return  safe;
}


void get_db_sizes(database *other, unsigned size[12])
{
   if (!other)
   {  if (!db)  error_stop(7,"in get_db_sizes: ");
      size[0] = db->nopri;
      size[1] = db->next_sigma - db->list;
      size[2] = db->next_power - db->powerheap;
      size[3] = db->next_prime - db->longprime;
      size[4] = table_size;
      size[5] = prime_heapsize;
      size[6] = factorisations;
      size[7] = power_heapsize;
   }
   else
   {  size[0] = other->nopri;
      size[1] = other->next_sigma - other->list;
      size[2] = other->next_power - other->powerheap;
      size[3] = other->next_prime - other->longprime;
      size[4] = (info *) other->longprime - other->table;
      size[5] = (longint *) other->list - other->longprime;
      size[6] = (vect *) other->powerheap - other->list;
      size[7] = (other->total_size - sizeof(database))/sizeof(pri_power)
                           -(other->powerheap - (pri_power *) other->table);
   }
}


int copy_db(database *other)
{
   unsigned  i;
   longint * prime_ptr;
   vect  *list_ptr;
   pri_power  *heap_ptr;
   if (!db)  error_stop(7,"in copy_db: ");
   if (!other)  error_stop(7,"in copy_db: ");
   if ((info *) other->longprime-other->table < db->nopri)
      return 3;
   if ((longint *) other->list-other->longprime < db->next_prime-db->longprime)
      return 4;
   if ((vect *) other->powerheap-other->list < db->next_sigma-db->list)
      return 5;
   if ((other->total_size - sizeof(database))/sizeof(pri_power)
                 -(other->powerheap - (pri_power *) other->table)
                            < db->next_power-db->powerheap)
      return 6;
   for (i=1;i<db->nopri;i++)
   {  other->table[i]= db->table[i];
      other->table[i].pri_addr -= db->longprime - other->longprime;
      if (other->table[i].sigma)
         other->table[i].sigma -= db->list - other->list;
   }
   for (i=0,prime_ptr=db->longprime;prime_ptr!=db->next_prime;i++)
      other->longprime[i]= *prime_ptr++;
   for (i=0,list_ptr=db->list;list_ptr!=db->next_sigma;i++)
   {  other->list[i]= *list_ptr++;
      other->list[i].fact_addr -= db->powerheap - other->powerheap;
   }
   for (i=0,heap_ptr=db->powerheap;heap_ptr!=db->next_power;i++)
   {  other->powerheap[i]= *heap_ptr++;
      other->powerheap[i].base -= db->table - other->table;
   }
   other->nopri = db->nopri;
   other->next_prime = db->next_prime - db->longprime + other->longprime;
   other->next_sigma = db->next_sigma - db->list + other->list;
   other->next_power = db->next_power - db->powerheap + other->powerheap;
   return 0;
}


int get_db_diff(database *other, unsigned *len, unsigned ind[], unsigned exp[])
{
   int  h;
   unsigned  i, j, k=0;
   info  *taddr, *dbaddr;

   if (!db)  error_stop(7,"in get_db_diff: ");
   if (!other)  error_stop(7,"in get_db_diff: ");
   for (i=j=1;i<db->nopri;i++)
   { 
      taddr = other->table+j;
      dbaddr = db->table+i;
      if (j==other->nopri || (h=zcompare(taddr->pri_addr,dbaddr->pri_addr)) > 0)
      {  for (h=1;h<=dbaddr->maxexpo;h++)
            if (dbaddr->sigma[h-1].fact_addr)
            {  if (k < *len)
                  ind[k]=i,  exp[k]=h;
               k++;
            }
      }
      else if (!h)
      {  for (h=1;h<=dbaddr->maxexpo;h++)
            if (h > taddr->maxexpo || !taddr->sigma[h-1].fact_addr)
               if (dbaddr->sigma[h-1].fact_addr)
               {  if (k < *len)
                     ind[k]=i,  exp[k]=h;
                  k++;
               }
         j++;
      }
      else
         i--, j++;
   }
   *len= k;
}


int merge_db(database *other)
{
   unsigned  i, j, k, len, exp[MAXFACTORS];
   int  h;
   long * pri[MAXFACTORS];
   pri_power  *heap_ptr;
   info  *taddr, *dbaddr;
   vect  *list_ptr;

   if (flags&32)
   {  flags |= 64;
      return 63;
   }
   if (!db)  error_stop(7,"in merge_db: ");
   if (!other)  error_stop(7,"in merge_db: ");
   for (i=j=1;j<other->nopri;i++)
   {  taddr = other->table+j;
      dbaddr = db->table+i;
      h= -1;
      if (i==db->nopri || (h=zcompare(taddr->pri_addr,dbaddr->pri_addr)) < 0)
         insert_prime_at(i,taddr->pri_addr); /* increase i virtually */
      if (h <= 0)
         j++; 
   }
   taddr = other->table+1;
   for (i=j=1;i<db->nopri;i++)
   {  dbaddr = db->table+i;
      if (!zcompare(taddr->pri_addr,dbaddr->pri_addr))
      {  if (dbaddr->maxexpo < taddr->maxexpo)
            alloc_factoring(i, taddr->maxexpo - dbaddr->maxexpo);
         for (k=1;k<=dbaddr->maxexpo;k++)
            if (!dbaddr->sigma[k-1].fact_addr)
            {  if (heap_ptr = taddr->sigma[k-1].fact_addr)
               {  len= taddr->sigma[k-1].no_factors;
                  if (db->next_power+len > db->powerheap+power_heapsize)
                     error_stop(5,"in merge_db: ");
                  list_ptr= dbaddr->sigma+k-1;
                  list_ptr->fact_addr = db->next_power;
                  list_ptr->no_factors = 0;
                  for (h=0;h<len;heap_ptr++,list_ptr->no_factors = ++h)
                  {  unsigned  index;
                     pri[h] = heap_ptr->base->pri_addr;
                     exp[h] = heap_ptr->expo;
                     if (!(index=lookup_primeaddr(pri[h])))
                     {  fprintf(stderr,"factorization merge:  ");
                        zfwrite(stderr, taddr->pri_addr,DEFAULT_LINE_LEN,"","");
                        fprintf(stderr,"%s%u :\n",TOP,k);
                        fprintf(stderr,"number not in heap: ");
                        zfwrite(stderr, pri[h],DEFAULT_LINE_LEN,"","");
                        fprintf(stderr,"\n");
                        error_stop(12,"in merge_db: ");
                     }
                     db->next_power->base= db->table + index;
                     db->next_power->expo= exp[h];
                     db->next_power->base->links += 1;
                     db->next_power++;
                  }
                  flags |= 1;
               }
            }
         j++;
         if (j==other->nopri)
            break;
         taddr++;
      }
   }
   return 0;
}


database * join_db(database *other)
{
   unsigned  i, j, k, m, len, sa_expo, ot_expo, exp[MAXFACTORS];;
   int  h;
   long * pri[MAXFACTORS];
   database  *safe, *temp;
   pri_power  *heap_ptr;
   info  *taddr, *saaddr;
   vect  *list_ptr;

   if (flags&32)
   {  flags |= 64;
      return (database *) 0;
   }
   if (!db)  error_stop(7,"in join_db: ");
   if (!other)  error_stop(7,"in join_db: ");
   safe= db;
   if (!(temp= create_db(table_size,prime_heapsize,factorisations,power_heapsize)))
      return  temp;
   access_db(temp);
   for (i=j=k=1;j<other->nopri || i<safe->nopri;i++,j++,k++)
   {  taddr = other->table+j;
      saaddr = safe->table+i;
      h= -1;
      if (i==safe->nopri || (h=zcompare(taddr->pri_addr,saaddr->pri_addr)) < 0)
      {  insert_prime_at(k,taddr->pri_addr);
         i--;
         alloc_factoring(k, taddr->maxexpo);
      }
      else if (j==other->nopri || h > 0)
      {  insert_prime_at(k,saaddr->pri_addr);
         j--;
         alloc_factoring(k, saaddr->maxexpo);
      }
      else
      {  insert_prime_at(k,saaddr->pri_addr);
         sa_expo=saaddr->maxexpo;
         ot_expo=taddr->maxexpo;
         alloc_factoring(k, sa_expo >= ot_expo ? sa_expo : ot_expo );
      }
   }
   for (i=j=k=1;j<other->nopri || i<safe->nopri;k++)
   {  taddr = other->table+j;
      saaddr = safe->table+i;
      if (i<safe->nopri && !zcompare(db->table[k].pri_addr,saaddr->pri_addr))
         sa_expo=saaddr->maxexpo, i++;
      else
         sa_expo=0;
      if (j<other->nopri && !zcompare(db->table[k].pri_addr,taddr->pri_addr))
         ot_expo=taddr->maxexpo, j++;
      else
         ot_expo=0;
      for (m=1;m<=db->table[k].maxexpo;m++)
      {  if (sa_expo >= m && (heap_ptr=saaddr->sigma[m-1].fact_addr))
            len= saaddr->sigma[m-1].no_factors;
         else if (ot_expo >= m && (heap_ptr=taddr->sigma[m-1].fact_addr))
            len= taddr->sigma[m-1].no_factors;
         else
            heap_ptr= (pri_power *) 0;
         if (heap_ptr)
         {  if (db->next_power+len > db->powerheap+power_heapsize)
               error_stop(5,"in merge_db: ");
            list_ptr= db->table[k].sigma+m-1;
            list_ptr->fact_addr = db->next_power;
            list_ptr->no_factors = 0;
            for (h=0;h<len;heap_ptr++,list_ptr->no_factors = ++h)
            {  unsigned  index;
               pri[h] = heap_ptr->base->pri_addr;
               exp[h] = heap_ptr->expo;
               if (!(index=lookup_primeaddr(pri[h])))
               {  fprintf(stderr,"factorization merge:  ");
                  zfwrite(stderr, db->table[k].pri_addr,DEFAULT_LINE_LEN,"","");
                  fprintf(stderr,"%s%u :\n",TOP,m);
                  fprintf(stderr,"number not in heap: ");
                  zfwrite(stderr, pri[h],DEFAULT_LINE_LEN,"","");
                  fprintf(stderr,"\n");
                  error_stop(12,"in merge_db: ");
               }
               db->next_power->base= db->table + index;
               db->next_power->expo= exp[h];
               db->next_power->base->links += 1;
               db->next_power++;
            }
         }
      }
   }
   access_db(safe);
   return  temp;
}


int get_fact(unsigned index, unsigned me, unsigned * len,
         unsigned ind[MAXFACTORS], unsigned exp[MAXFACTORS])
{
   unsigned  j;
   pri_power  *heap_ptr;
   info  *taddr;
   if (!db)  error_stop(7,"in get_fact: ");
   if (index <= 0 || index >= db->nopri)
      error_stop(1,"in get_fact: ");
   taddr = db->table+index;
   if (!me || me > taddr->maxexpo)
      return -1;
   if (heap_ptr = taddr->sigma[me-1].fact_addr)
   {
      *len= taddr->sigma[me-1].no_factors;
      for (j=0;j< *len;j++,heap_ptr++)
      {  ind[j] = heap_ptr->base - db->table;
         exp[j] = heap_ptr->expo;
      }
      return 0;
   }
   else
      return -2;
}


void update_indices(unsigned *updc, unsigned (*updl)[], unsigned (**updp)[],
                    unsigned (*upds)[], void (*updh)(int) )
{
   if (!db)  error_stop(7,"in update_indices: ");
   db->upd_count = updc;
   db->upd_len = updl;
   db->upd_ind = updp;
   db->upd_step = upds;
   db->upd_hand = updh;
   return ;
}


static void do_update_indices(int ind)
{
   unsigned  h=0, i, j, index, k;
   if (index >= 0)
      index= ind, k=1;
   else
      index= -ind, k= -1;
   if (db->upd_count && db->upd_len && db->upd_ind && db->upd_step)
      for (i=0;i< *db->upd_count;i++)
         for (h=(*db->upd_len)[i],j=0;h;h--,j+=(*db->upd_step)[i])
            if (*db->upd_ind[i]  &&  *(*db->upd_ind[i]+j) >= index)
               *(*db->upd_ind[i]+j) += k;
   if (db->upd_count && db->upd_hand)
      db->upd_hand(ind);
   return;
}


int read_fact(char * buffer, unsigned *len, unsigned ind[MAXFACTORS],
              unsigned  exp[MAXFACTORS])
{
   int  i, j;
   static long  *base[MAXFACTORS];
   char  delim;
   if (!db)  error_stop(7,"in read_fact: ");
   for (i=0;i<MAXFACTORS;i++)
      base[i] = (long *) 0;
   j=0;
   for (*len=0;;(*len)++)
   {  for (;buffer[j]<'0' || buffer[j]>'9';j++)
         if (buffer[j]<' ')  break;
      if (buffer[j]<' ')  break;
      for (i=j;buffer[i]>='0' && buffer[i]<='9';i++);
      if (i==j)  break;
      if (*len > MAXFACTORS)
         error_stop(6,"in read_fact: ");
      delim= buffer[i];
      buffer[i]='\0';
      zsread(buffer+j,&base[*len]);
      if (!(ind[*len]=lookup_primeaddr(base[*len])))
         printf("non prime or not in heap: %s\n",buffer+j);
      buffer[i]=delim;
      j=i;
      while (buffer[i]&&TOP[i-j]&&buffer[i]==TOP[i-j])
         i++;
      if (!TOP[i-j])
      {  for (j=i;buffer[j]<'0' || buffer[j]>'9';j++)
            if (buffer[j]<' ')  break;
         if (buffer[j]<' ')  break;
         for (i=j;buffer[i]>='0' && buffer[i]<='9';i++);
         if (i==j)  break;
         delim= buffer[i];
         buffer[i]='\0';
         sscanf(buffer+j,"%u",&exp[*len]);
         buffer[i]=delim;
         j=i;
      }
      else
         exp[*len]=1;
      j++;
   }
   for (i=0;i<*len;i++)
      zfree(&base[i]);
   return  0;
}


int heap_was_modified()
{
   return  flags&1;
}
