#ifndef  __MPER                        /*  Date:  2007-12-17   Version  4.1d */
#include <stdio.h>
#include <stdlib.h>  /* void * calloc(..), void free(void*) */
#define  longint   unsigned long

#ifndef  TABSIZE
#define  TABSIZE     12500
#endif
#ifndef  FACTSIZE
#define  FACTSIZE    15000
#endif
#ifndef  PRIMEHEAP
#define  PRIMEHEAP   34000
#endif
#ifndef  POWERHEAP
#define  POWERHEAP   60000
#endif
#ifndef  MAXFACTORS
#define  MAXFACTORS    128
#endif

#ifndef  MAX_PRIME_LENGTH
#define  MAX_PRIME_LENGTH  1024  /* maximal trusted prime length in bytes */
#endif


typedef struct s_i
      {  longint  *pri_addr;
         unsigned  maxexpo;
         struct s_v  *sigma;
         unsigned  links;
      } info ; 

typedef struct s_v
      {
         struct s_p  *fact_addr;
         unsigned  no_factors;
      }  vect;

typedef struct s_p
      {  struct s_i  *base;
         unsigned  expo;
      }  pri_power;

typedef  struct
{
   info          *table;
   longint       *longprime;
   vect          *list;
   pri_power     *powerheap;
   unsigned      nopri;
   unsigned      total_size;
   longint       *next_prime;
   vect          *next_sigma;
   pri_power     *next_power;
   unsigned      *upd_count;
   unsigned      (* upd_len)[];
   unsigned      (* upd_step)[];
   unsigned      (* * upd_ind)[];
   void (*upd_hand)(int);
} database;


int         create_heap(unsigned  max_two_expo, unsigned  sievesize);
unsigned    get_maxindex();
int         get_primeaddr(long *number);
long *      get_prime(unsigned index);
int         valid_table_addr(unsigned index);
unsigned    get_maxexpo(unsigned index);
unsigned    lookup_primeaddr(long *number);
int         alloc_factoring(unsigned index, int  anz);
int         valid_factoring(unsigned index, unsigned  me);
unsigned    size_of_factoring(unsigned index, unsigned me);
int         write_factoring(unsigned index, unsigned  me, char  *buffer);
int         read_factoring(unsigned index, unsigned  me, char  *buffer);
int         compute_factoring(unsigned index, unsigned  me);
int         chain_factoring(long *number, unsigned  me);
int         get_factoring(unsigned index, unsigned  me,  unsigned  *len,
                          long  *pri[],  unsigned  exp[]);
int         update_factoring(unsigned index, unsigned  me, unsigned  len,
                             long  *pri[],  unsigned  exp[]);
int         add_factoring(unsigned index);
void        heap_info();
int         size_info(void *  db_info[16]);
int         save_heap(char  *filename);
int         load_heap(char  *filename);
int         merge_heap(char  *filename);
int         info_heap(char  *filename, unsigned size[16]);
int         check_heap(unsigned  probprime_tests,  unsigned check_mask,
                       unsigned  check_param);
unsigned    change_heap_entry_type();
unsigned    change_longint_compact_type();
int         search_fact(unsigned bits);
int         write_sigma_chain(unsigned index, unsigned  me, unsigned  bits);
int         delete_factoring(unsigned index, unsigned me);
int         next_refer(unsigned index, unsigned *start, unsigned *me);
unsigned    get_prime_count(unsigned index);
int         delete_prime(unsigned index);
int         load_oldheap(char * filename);
int         get_fact(unsigned index, unsigned me, unsigned * len,
                     unsigned ind[MAXFACTORS], unsigned exp[MAXFACTORS]);
int         read_fact(char * buffer, unsigned *len, unsigned ind[MAXFACTORS],
                      unsigned  exp[MAXFACTORS]);
void        update_indices(unsigned *updc, unsigned (*updl)[],
                           unsigned (**updp)[], unsigned (*upds)[],
                           void (*updh)(int) );
int         heap_was_modified();

database *  access_db(database *other);
database *  create_db(unsigned tabsize, unsigned primsize, unsigned factsize,
                      unsigned powersize);
void        delete_db(database *other);
void        get_db_sizes(database *other, unsigned size[12]);
int         copy_db(database *other);
int         merge_db(database *other);
database *  join_db(database *other);
int         get_db_diff(database *other, unsigned *len, unsigned ind[],
                        unsigned exp[]);

#define  __MPER
#endif
